#define NOMINMAX
#include <bblean/BBApi.h>

enum {BBLEAN,BB4WIN,XOBLITE};
int branch=0;
bool left=false;
bool skipIconic = false;
char rcpath[MAX_PATH];
HINSTANCE hInstance;
static HANDLE   hProcess = NULL;
static HWND     hPluginWnd = NULL;
static int      bb_messages[] = {BB_BROADCAST, BB_RECONFIGURE, BB_DESKTOPINFO, BB_WORKSPACE, BB_WINDOWMINIMIZE, BB_BRINGTOFRONT, BB_TASKSUPDATE, 0};
DesktopInfo currentDeskInfo,oldDeskInfo;
void ReadRCSettings(void);

LPCSTR pluginInfo(int x)
{
	switch (x)
	{
		case PLUGIN_NAME:			return "SkipDesk";
		case PLUGIN_VERSION:		return "0.0.2";
		case PLUGIN_AUTHOR:			return "Carsomyr";
		case PLUGIN_RELEASEDATE:	return "2006/02/21";
		case PLUGIN_LINK:			return "None";
		case PLUGIN_EMAIL:			return "s23120712@tuks.co.za";
		default:					return "SkipDesk 0.0.2";
	}
}

//---------------------------------------------------------------------------------
LRESULT CALLBACK PluginProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch(message)
    {
	case BB_BROADCAST:
		break;
	case BB_RECONFIGURE:
		ReadRCSettings();
		break;
	case BB_DESKTOPINFO:
	{
		currentDeskInfo=*((DesktopInfo*)lParam);
		if (currentDeskInfo.isCurrent)
		{
			//if (currentDeskInfo.number!=oldDeskInfo.number)
			{
				bool empty=true;
				for(int i=0;i<GetTaskListSize();++i)
				{
					if ((currentDeskInfo.number==GetTaskWorkspace(GetTask(i)))/*&&*/)
					{
						if (!(IsIconic(GetTask(i))&&skipIconic))
						{
							empty=false;
							break;
						}
					}
				}
				if (empty&&!(0x8000 & GetAsyncKeyState(VK_MENU))) 
				{
					if (GetTaskListSize()==0)
						SendMessage(GetBBWnd(),BB_WORKSPACE,BBWS_SWITCHTODESK,0);
					else if (left)
						SendMessage(GetBBWnd(),BB_WORKSPACE,BBWS_DESKLEFT,0);
					else
						SendMessage(GetBBWnd(),BB_WORKSPACE,BBWS_DESKRIGHT,0);
					//else if (oldDeskInfo.number==currentDeskInfo.number)
					//	SendMessage(GetBBWnd(),BB_WORKSPACE,BBWS_DESKLEFT,0);
				}
			}
			oldDeskInfo=currentDeskInfo;
		}
		break;
	}
	case BB_WORKSPACE:
	{
		if (wParam == BBWS_DESKLEFT) left = true;
		if (wParam == BBWS_MOVEWINDOWLEFT) left = true;
		if (wParam == BBWS_DESKRIGHT) left = false;
		if (wParam == BBWS_MOVEWINDOWRIGHT) left = false;
		if ((wParam!=BBWS_MINIMIZEALL)&&GetTaskListSize()) SendMessage(GetBBWnd(),BB_LISTDESKTOPS,WPARAM(hwnd),0);
		break;
	}
	case BB_TASKSUPDATE:
		if (lParam==TASKITEM_REMOVED)
			SendMessage(GetBBWnd(),BB_LISTDESKTOPS,WPARAM(hwnd),0);
		break;
	case BB_WINDOWMINIMIZE:
		SendMessage(GetBBWnd(),BB_LISTDESKTOPS,WPARAM(hwnd),0);
		break;
	default:return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

//---------------------------------------------------------------------------------

int beginPluginEx(HINSTANCE h_instance, HWND hSlit)
{
    return beginPlugin(h_instance);
}

int beginSlitPlugin(HINSTANCE h_instance, HWND hSlit)
{
    return beginPlugin(h_instance);
}

int beginPlugin(HINSTANCE h_instance)
{
	#ifdef LOG
	logFile.open("log.txt");
	#endif
    hInstance=h_instance;
    if (!strnicmp(GetBBVersion(),"bblean",6))
        branch=BBLEAN;
    else if (!strnicmp(GetBBVersion(),"0.",2))
        branch=BB4WIN;
    else
        branch=XOBLITE;
    ReadRCSettings();
    WNDCLASS wc;
    ZeroMemory(&wc, sizeof(wc));
    wc.lpfnWndProc = PluginProc;
    wc.hInstance = h_instance;
    wc.lpszClassName = pluginInfo(PLUGIN_NAME);
    RegisterClass(&wc);

    hPluginWnd = CreateWindowEx(
        WS_EX_TOOLWINDOW,
        pluginInfo(PLUGIN_NAME),
        NULL,
        WS_POPUP|WS_ICONIC,
        -4, -4, 0, 0,
        HWND_MESSAGE,
        NULL,
        h_instance,
        NULL
    );
    hProcess = GetCurrentProcess();
    SendMessage(GetBBWnd(), BB_REGISTERMESSAGE, (WPARAM)hPluginWnd, (LPARAM)bb_messages);
    strcpy(oldDeskInfo.name,"");
	oldDeskInfo.number=-1;
	SendMessage(GetBBWnd(),BB_LISTDESKTOPS,WPARAM(hPluginWnd),0);
    return 0;
}

//---------------------------------------------------------------------------------

void endPlugin(HINSTANCE h_instance)
{
    DestroyWindow(hPluginWnd);
    SendMessage(GetBBWnd(), BB_UNREGISTERMESSAGE, (WPARAM)hPluginWnd, (LPARAM)bb_messages);
    UnregisterClass(pluginInfo(PLUGIN_NAME), h_instance);
}

//---------------------------------------------------------------------------------
void ReadRCSettings(void)
{
    char name[MAX_PATH];
	int i = 0;
	do
	{
		// First and third, we look for the config file
		// in the same folder as the plugin...
		HINSTANCE hInst = hInstance;
		//Allow us to get the name of dll used
		GetModuleFileName(hInst, rcpath, sizeof(rcpath));
		char *plugin_name = strrchr(rcpath, '\\');
		plugin_name++;
		char *extension_start = strrchr(plugin_name, '.');
		extension_start++;
		extension_start[0]='r';
        extension_start[1]='c';
        extension_start[2]=0;
        strcpy(name,plugin_name);
		// second we check the blackbox directory
		if (1 == i) hInst = NULL;

		GetModuleFileName(hInst, rcpath, sizeof(rcpath));
		char *file_name_start = strrchr(rcpath, '\\');
                
		if (file_name_start) ++file_name_start;
		else file_name_start = strchr(rcpath, 0);
		strcpy(file_name_start, name);
	} 
	while (++i < 3 && false == FileExists(rcpath));
	// If a config file was found we read the plugin settings from it...
	// ...if not, the ReadXXX functions give us just the defaults.
	skipIconic = ReadBool(rcpath, "SkipDesk.SkipIconic:",false);
}
